# Name:        LostBomb v1.0
# Author:      JoeyT2007
# Description: Returns the bomb to a random/nearest terrorist if 'lost'.

import es, playerlib, gamethread, random, vecmath

####SETTINGS####
lb_type = es.ServerVar("lb_type", "1", "Type of return, 0 = Return to random terrorist; 1 = Return to nearest terrorist.")
lb_losttimer = es.ServerVar("lb_losttimer", "30", "How long before the bomb is returned.")
lb_c4_beacon = es.ServerVar("lb_c4_beacon", "1", "Shows a green beacon around the bomb when dropped. Easier to find. (REQUIRES ES_TOOLS) (CANNOT BE RUN ON LISTEN SERVER)")
lb_c4_radius = es.ServerVar("lb_c4_radius", "600", "If a terrorist is within this radius of the bomb, the bomb is not lost.")
################

lostbomb_ver = "1.0"
lostbomb_ver.makepublic()

info = es.AddonInfo()
info.name = "LostBomb"
info.version = "1.0"
info.author = "JoeyT2007"
info.url = "http://forums.mattie.info/cs/forums/viewtopic.php?p=168011"
info.description = "Returns the bomb to a random/nearest terrorist if 'lost'."
info.basename = "lostbomb"

def unload():
    gamethread.cancelDelayed("beacon")
    gamethread.cancelDelayed("lostbomb")

def bomb_pickup(event_var):
    gamethread.cancelDelayed("beacon")
    gamethread.cancelDelayed("lostbomb")

def bomb_dropped(event_var):
    gamethread.delayedname(1.5, "beacon", beacon)
    gamethread.delayedname(lb_losttimer, "lostbomb", lostbomb)

def lostbomb():
    if lb_type == 0:
        lostbomb_random()
    if lb_type == 1:
        lostbomb_nearest()

def lostbomb_random():
    lb_t_inrange = 0
    lb_c4_list = es.createentitylist('weapon_c4')
    lb_c4_count = len(lb_c4_list)
    if lb_c4_count == 1:
        lb_planted_c4 = es.getentityindex("planted_c4")
        if lb_planted_c4 == -1:
            lb_c4 = es.getentityindex("weapon_c4")
            lb_playerlist = playerlib.getPlayerList('#t,#alive')
            for lb_userid in lb_playerlist:
                lb_userid_location = es.getplayerprop(int(lb_userid), "cbaseentity.m_vecorigin")
                lb_c4_location = es.getindexprop(lb_c4, "cbaseentity.m_vecorigin")
                lb_distance = vecmath.distance(lb_userid_location, lb_c4_location)
                if lb_distance <= lb_c4_radius:
                    lb_t_inrange = 1
    if lb_t_inrange == 0:
        lb_userid = random.choice(lb_playerlist)
        lb_userid = int(lb_userid)
        lb_username = es.getplayername(lb_userid)
        es.msg("#multi", "#green[LostBomb]#default The #lightgreenbomb#default was lost, it has been given to#lightgreen %s" % lb_username)
        es.remove(lb_c4)
        es.give(lb_userid, "weapon_c4")
    else:
        gamethread.delayedname(1, "lostbomb", lostbomb)

def lostbomb_nearest():
    lb_t_inrange = 0
    lb_t_nearest = 0
    lb_c4_range = 500000
    lb_c4_list = es.createentitylist('weapon_c4')
    lb_c4_count = len(lb_c4_list)
    if lb_c4_count == 1:
        lb_planted_c4 = es.getentityindex("planted_c4")
        if lb_planted_c4 == -1:
            lb_c4 = es.getentityindex("weapon_c4")
            lb_playerlist = playerlib.getPlayerList('#t,#alive')
            for lb_userid in lb_playerlist:
                lb_userid_location = es.getplayerprop(int(lb_userid), "cbaseentity.m_vecorigin")
                lb_c4_location = es.getindexprop(lb_c4, "cbaseentity.m_vecorigin")
                lb_distance = vecmath.distance(lb_userid_location, lb_c4_location)
                if lb_distance <= lb_c4_range:
                    lb_t_nearest = lb_userid
                    lb_c4_range = lb_distance
                if lb_distance <= lb_c4_radius:
                    lb_t_inrange = 1
    if lb_t_inrange == 0:
        if lb_t_nearest != 0:
            lb_userid = int(lb_t_nearest)
            lb_username = es.getplayername(lb_userid)
            es.msg("#multi", "#green[LostBomb]#default The #lightgreenbomb#default was lost, it has been given to#lightgreen %s" % lb_username)
            es.remove(lb_c4)
            es.give(lb_userid, "weapon_c4")
    else:
        gamethread.delayedname(1, "lostbomb", lostbomb)

def beacon():
    lb_c4_list = es.createentitylist('weapon_c4')
    lb_c4_count = len(lb_c4_list)
    if lb_c4_count == 1:
        lb_planted_c4 = es.getentityindex("planted_c4")
        if lb_planted_c4 == -1:
            lb_c4 = es.getentityindex("weapon_c4")
            if lb_c4_beacon == 1:
                lb_c4_location = es.getindexprop(lb_c4, "CBaseEntity.m_vecOrigin")
                (lb_c4_x, lb_c4_y, lb_c4_z) = es.splitvectorstring(lb_c4_location)
                es.server.cmd('est_effect 10 #all 0 "sprites/lgtning.vmt" %s %s %s 0 125 1 1 1 1 0 255 0 255 0' % (str(lb_c4_x), str(lb_c4_y), str(lb_c4_z)))
    gamethread.delayedname(0.5, "beacon", beacon)